
{///////////////////////////////////////////////////////////////////////////}
{/                                                                         /}
{/  UNI - DRUCK : Ermglicht den Ausdruck von ASCII - Dateien auf ver-     /}
{/                schiedenen Druckern. Durch eine Anpassungstabelle lassen /}
{/                sich beliebige Drucker leicht installieren.              /}
{/                Dabei knnen wahlweise auch Zeilennummern, z.B. zum      /}
{/                Druck von Programmquellen, hinzugefgt werden.           /}
{/                                                                         /}
{/  Dieses PUBLIC DOMAIN Programm wurde 1987 mit ST Pascal plus von CCD    /}
{/                                                                         /}
{/  entwickelt von                                    ERHARD SCHWARTZ      /}
{/                                                    Isaraustr. 8         /}
{/  Version vom 13.09.1987                        D - 8192 Geretsried 1    /}
{/                                                                         /}
{///////////////////////////////////////////////////////////////////////////}

{$S10} { Heap und Stack belegen maximal 10k }

PROGRAM UNI_DRUCK_by_ERHARD_SCHWARTZ;

CONST   VERSION = '1.10';

        {$I GEMCONST.INC}
        {$I UNIDRUCK.I  }       { Includefile aus Resource Construction }

        MUSTER          = 6;                    { Hintergrundmuster }
        ST_X            = 150;                  { Startwerte fr Grow-Box }
        ST_Y            = 300;
        ST_W            = 50;
        ST_H            = 30;
        RSC_DATEI       = 'UNIDRUCK.RSC';       { Name der Resource-Datei }
        OUT_DEVICE      = 'LST:';               { parallele Schnittstelle }

TYPE
        {$I GEMTYPE.INC}

        c_string        = PACKED ARRAY [ 1 .. 81 ] OF CHAR;
        c_string_14     = PACKED ARRAY [ 1 .. 14 ] OF CHAR;

        dta_buffer      = PACKED RECORD
                                   reserved  : PACKED ARRAY [0..19] OF CHAR;
                                   reserved2 : BYTE;
                                   attribut  : BYTE;
                                   uhrzeit   : INTEGER;
                                   datum     : INTEGER;
                                   laenge    : LONG_INTEGER;
                                   name      : c_string_14;
                                 END;

        ctrl_parms      = ARRAY[0..11] OF INTEGER;
        int_in_parms    = ARRAY[0..15] OF INTEGER;
        int_out_parms   = ARRAY[0..45] OF INTEGER;
        addr_in_parms   = ARRAY[0..1]  OF ^CHAR;
        addr_out_parms  = ARRAY[0..0]  OF ^CHAR;
        pts_in_parms    = ARRAY[0..11] OF INTEGER;
        pts_out_parms   = ARRAY[0..11] OF INTEGER;


        steuerseq_typ   = ( p_name, p_lrand, p_init, p_exit, p_pica,
                            p_elite,p_schmal, p_kl_ue, p_kl_ae, p_gr_ae,
                            p_kl_oe,p_gr_oe, p_gr_ue, p_dt_sz, p_dt_para );
        voreinst_typ    = ( p_seitlaen, p_tab, p_v_lrand, p_pica_breit,
                            p_elite_breit, p_schmal_breit );
        str21           = STRING[21];

VAR
    t           : str255;
    mist        : INTEGER;
    x, y, w, h  : INTEGER;                      { Objektkoordinaten }
    dl_x, dl_y, dl_w, dl_h      : INTEGER;      { Mae des Haupt-Dialogs }
    id_x, id_y, id_w, id_h      : INTEGER;      { Mae des Info-Dialogs }

    dta         : dta_buffer;
    drive       : CHAR;
    c_path      : c_string;
    vorschlag,
    pfad        : STRING;
    q_laenge    : LONG_INTEGER;

    p_string    : ARRAY[ p_name .. p_dt_para ] OF ARRAY[ 1 .. 3 ] OF str21;
    p_vor       : ARRAY[ p_seitlaen .. p_schmal_breit ] OF
                  ARRAY[ 1 .. 3 ] OF INTEGER;

    tab_weite,                                  { Drucker - Parameter }
    randbreite,
    zeilenbreite,
    drucker     : INTEGER;

    dl,                                         { Hauptdialog }
    id                  : dialog_ptr;           { Info-Dialog }

    fenster,
    f_x, f_y, f_w, f_h  : INTEGER;              { Fenster-Daten }
    fenstername : window_title;

    int_in      : int_in_parms;         { Parameter fr AES Aufrufe }
    int_out     : int_out_parms;
    addr_in     : addr_in_parms;
    addr_out    : addr_out_parms;


{///////  DEKLARATION DER UNTERPROGRAMME  //////////////////////////////////}

      {$I GEMSUBS.INC}

PROCEDURE       fsetdta ( VAR dta : dta_buffer );       GEMDOS ( $1A );

PROCEDURE       aes_call ( op : INTEGER; VAR int_in   : int_in_parms;
                                         VAR int_out  : int_out_parms;
                                         VAR addr_in  : addr_in_parms;
                                         VAR addr_out : addr_out_parms);
                                                        EXTERNAL;

{***********   G E T _ D R I V E   *****************************************}

FUNCTION get_drive : CHAR;
  FUNCTION dgetdrv : INTEGER; GEMDOS ($19);
BEGIN get_drive := chr( dgetdrv + 65 ); END;


{***********   G E T _ P A T H   *******************************************}

FUNCTION get_path ( VAR path : c_string ) : INTEGER;
  FUNCTION dgetpath ( VAR path:c_string; drv:INTEGER ):INTEGER; GEMDOS($47);
BEGIN
  get_path := dgetpath( path, 0);       { 0= Pfad des aktuellen Laufwerks }
END;


{***********   A N A L Y Z E _ P A T H   ***********************************}

PROCEDURE analyze_path( VAR path, name, extension : STRING);
VAR     i, len, punkt : INTEGER;
BEGIN
  len   := length( path);
  IF len = 0
  THEN BEGIN name := ''; extension := '' END { Leerstring als Pfad }
  ELSE BEGIN
         i     := len;
         punkt := 0;
         LOOP
           IF path[i] = '.' THEN punkt := i;
         EXIT IF ( path[i] = '\' ) OR ( i = 1 );
           i := i - 1;
         END; { loop }
         IF punkt > 0
         THEN extension := copy( path, punkt + 1, len - punkt)
         ELSE BEGIN
                extension := '';
                punkt := len + 1;
              END;
         IF i = 1 THEN i := 0;            { gleiche Zhlweise garantieren }
         name  := copy( path, i + 1, punkt - i - 1);
       END; { Pfad war vernnftig }
END; { procedure analyze_path }


{***********   P A S _ T O _ C   *******************************************}

PROCEDURE pas_to_c ( str : STRING; VAR c_str : c_string);
VAR i : INTEGER;
BEGIN
  FOR i := 1 TO length( str) DO c_str[i] := str[i];
  c_str[ length( str) + 1] := #0;               { Abschlu mit ASCII 0 }
END; { procedure pas_to_c }


{***********   C _ T O _ P A S   *******************************************}

PROCEDURE c_to_pas ( VAR c_str : c_string; VAR s : STRING );
VAR i : INTEGER;
BEGIN
  i := 1;
  WHILE ( c_str[i] <> #0 ) AND ( i < 81 ) DO
  BEGIN
    s[i] := c_str[i];
    i := i + 1;
  END;
  s[0] := chr ( i - 1 );
END; { procedure c_to_pas }


{***********   U P C A S E   ***********************************************}

FUNCTION upcase ( ch : CHAR ) : CHAR;
BEGIN
  IF ( ch >= 'a') AND ( ch <= 'z' )
  THEN upcase := chr( ord( ch) - 32 )
  ELSE CASE ch OF
         ''  : upcase := '';
         ''  : upcase := '';
         ''  : upcase := '';
         ELSE : upcase := ch;
       END; { case }
END; { upcase }


{***********   E X I S T   *************************************************}

FUNCTION exist( filnam : STRING ) : BOOLEAN;
VAR path      : c_string;
  FUNCTION fsfirst ( VAR p : c_string; att:INTEGER) : INTEGER; GEMDOS($4E);
BEGIN { function exist }
  pas_to_c( filnam, path);
  exist := ( fsfirst( path, $20|$01) = 0 );      { Sucht nur nach         }
END; { function exist }                          { 'ordentlichen' Dateien }



{***********   L O N G _ T O _ S T R I N G   *******************************}

PROCEDURE long_to_string ( altlong : LONG_INTEGER; VAR str : STRING);
VAR long, rest : LONG_INTEGER;
BEGIN
  str := '';
  long := abs ( altlong );
  IF long = 0 THEN str := concat( str, '0');
  WHILE long > 0 DO
  BEGIN
    rest   := long DIV 10;
    str := concat( chr( long - 10*rest + 48), str);
    long   := rest;
  END; { while }
  IF altlong < 0 THEN str := concat( '-', str);
END; { procedure long_to_string }


{***********   D R U C K E R _ B E R E I T   *******************************}

FUNCTION drucker_bereit : BOOLEAN;
  FUNCTION cprnos : INTEGER; GEMDOS($11);
BEGIN drucker_bereit := ( cprnos = -1 ); END; { function drucker_bereit }


{///////  FORWARD-DEKLARATIONEN  ///////////////////////////////////////////}

PROCEDURE neuer_wert( welcher, wert : INTEGER; zeichnen : BOOLEAN); FORWARD;


{///////  INITIALISIERUNG EINIGER STARTWERTE  //////////////////////////////}

PROCEDURE initialisiere;
BEGIN
  drucker       := 1;
  tab_weite     := p_vor[ p_tab        , drucker];
  randbreite    := p_vor[ p_v_lrand    , drucker];
  zeilenbreite  := p_vor[ p_pica_breit , drucker];

  neuer_wert( TABWEITE, tab_weite,    FALSE);
  neuer_wert( RANDBREI, randbreite  , FALSE);
  neuer_wert( ZEILBREI, zeilenbreite, FALSE);

  set_dtext( dl, VERSIONR, VERSION, SYSTEM_FONT, TE_LEFT);
  set_dtext( id, VERSIINF, VERSION, SYSTEM_FONT, TE_LEFT);
  set_dtext( dl, DATEINAM, '????????.???', SYSTEM_FONT, TE_RIGHT);

  obj_setstate( dl, LPTR1BTN, obj_state( dl, LPTR1BTN) | SELECTED, FALSE);
  obj_setstate( dl, PICASCHR, obj_state( dl, PICASCHR) | SELECTED, FALSE);
  obj_setstate( dl, NUMMERNE, obj_state( dl, NUMMERNE) | SELECTED, FALSE);
  obj_setstate( dl, PERFORJA, obj_state( dl, PERFORJA) | SELECTED, FALSE);

  drive := get_drive;
  mist  := get_path( c_path);
  c_to_pas( c_path, vorschlag);
  vorschlag := concat( drive, ':', vorschlag, '\*.*');

END; { procedure initialisiere }


{///////  DRUCKERVOREINSTELLUNGEN BERNEHMEN  //////////////////////////////}

PROCEDURE neuer_drucker( welcher_knopf : INTEGER );
BEGIN
  CASE welcher_knopf OF
    LPTR1BTN : drucker := 1;
    LPTR2BTN : drucker := 2;
    LPTR3BTN : drucker := 3;
  END; { case }

  tab_weite     := p_vor[ p_tab        , drucker];
  randbreite    := p_vor[ p_v_lrand    , drucker];

  IF (obj_state( dl, PICASCHR) & SELECTED <>0)
  THEN zeilenbreite  := p_vor[ p_pica_breit , drucker];
  IF (obj_state( dl, ELITESCH) & SELECTED <>0)
  THEN zeilenbreite  := p_vor[ p_elite_breit , drucker];
  IF (obj_state( dl, SCHMALSC) & SELECTED <>0)
  THEN zeilenbreite  := p_vor[ p_schmal_breit , drucker];

END; { neuer_drucker }


{///////  AUSWERTEN EINES STRINGS, DER EINE HEX-ZAHL ENTHLT  //////////////}

FUNCTION hexstring_to_char( h : STRING; VAR wert : CHAR) : BOOLEAN;
VAR i, z : INTEGER;
    ch : CHAR;
BEGIN { hexstring_to_char }
  z := 0;
  FOR i := 1 TO length( h)DO
  BEGIN
    ch := upcase ( h[i]);
    IF ch IN ['0'..'9']
    THEN z := 16 * z + ord( ch) - 48
    ELSE z := 16 * z + ord( ch) - 55;
  END;
  IF ( z >= 0 ) AND ( z <= 255 )
  THEN BEGIN
         hexstring_to_char := TRUE;
         wert := chr( z);
       END
  ELSE hexstring_to_char := FALSE;
END; { hexstring_to_char }


{///////  EINLESEN UND AUSWERTEN DER DRUCKERANPASSUNGSTABELLE  /////////////}

PROCEDURE werte_datei_aus( name : STRING; p_nr : INTEGER );
VAR q           : TEXT;
    seq         : steuerseq_typ;
    wert        : str21;
    str         : STRING[255];
    n,
    i           : INTEGER;
    h           : STRING;
    ch          : CHAR;
    stop        : BOOLEAN;
BEGIN
    reset( q, name);
    WHILE NOT eof( q) DO
    BEGIN
        i       := 0;
        h       := '';
        wert    := '';
        readln( q, str);
        IF str <> '' THEN
        REPEAT
          i := i + 1;
          IF str[i] IN ['0'..'9', 'a'..'f', 'A'..'F']
          THEN BEGIN
                 h := concat( h, str[i]);
               END
          ELSE BEGIN
                 IF h <> ''
                 THEN BEGIN
                        stop := NOT hexstring_to_char( h, ch);
                        IF NOT stop THEN wert := concat ( wert, ch);
                        h := '';
                      END;
               END;
        UNTIL (i >= length( str)) OR stop OR
              NOT ( str[i] IN ['0'..'9','a'..'f','A'..'F',' ',','] );
        IF h <> ''
        THEN BEGIN
               stop := NOT hexstring_to_char( h, ch);
               IF NOT stop THEN wert := concat ( wert, ch);
             END;
        IF length( wert) >= 1
        THEN BEGIN
               seq := p_name;
               CASE wert[1] OF
                 #$00 : BEGIN
                          i := pos( '''', str) + 1;
                          n := length( str) - i;
                          IF n > 10 THEN n := 10;
                          p_string[ p_name, p_nr] := copy( str, i, n);
                          i := pos( '''', p_string[ p_name, p_nr]);
                          IF i > 0
                          THEN p_string[ p_name, p_nr, 0] := chr(i-1);
                        END;
                 #$05 : seq := p_lrand;
                 #$1F : seq := p_init ;
                 #$21 : seq := p_exit ;
                 #$28 : seq := p_pica ;
                 #$2A : seq := p_elite;
                 #$2C : seq := p_schmal;

                 #$50 : p_vor[ p_seitlaen     , p_nr] := ord( wert[2]);
                 #$51 : p_vor[ p_tab          , p_nr] := ord( wert[2]);
                 #$52 : p_vor[ p_v_lrand      , p_nr] := ord( wert[2]);
                 #$53 : p_vor[ p_pica_breit   , p_nr] := ord( wert[2]);
                 #$54 : p_vor[ p_elite_breit  , p_nr] := ord( wert[2]);
                 #$55 : p_vor[ p_schmal_breit , p_nr] := ord( wert[2]);

                 #$81 : seq := p_kl_ue  ;
                 #$84 : seq := p_kl_ae  ;
                 #$8E : seq := p_gr_ae  ;
                 #$94 : seq := p_kl_oe  ;
                 #$99 : seq := p_gr_oe  ;
                 #$9A : seq := p_gr_ue  ;
                 #$9E : seq := p_dt_sz  ;
                 #$DD : seq := p_dt_para;
               END; { case }

               IF seq <> p_name
               THEN p_string[ seq, p_nr] := copy( wert, 2,length(wert)-1);
             END; { Es war mindestens ein Wert eingetragen }
    END; { while not eof }
    close( q);
END; { werte_datei_aus }


{///////  INITIALISIEREN DER DRUCKERANPASSUNGEN  ///////////////////////////}

PROCEDURE welche_drucker_sind_da;
VAR     index           : ARRAY[1..3] OF INTEGER;
        welcher         : INTEGER;
        seq             : steuerseq_typ;
        filnam          : STRING;
BEGIN
  index[1]      := LPTR1BTN;
  index[2]      := LPTR2BTN;
  index[3]      := LPTR3BTN;
  FOR welcher := 3 DOWNTO 1 DO
  BEGIN
    FOR seq := p_name  TO p_schmal  DO p_string[ seq, welcher] := '';
    FOR seq := p_kl_ue TO p_dt_para DO p_string[ seq, welcher] := ' ';

    p_vor[ p_seitlaen,     welcher] := 65;
    p_vor[ p_tab,          welcher] := 8;
    p_vor[ p_v_lrand,      welcher] := 0;
    p_vor[ p_pica_breit,   welcher] := 80;
    p_vor[ p_elite_breit,  welcher] := 80;
    p_vor[ p_schmal_breit, welcher] := 80;

    filnam := concat('UNIDRUCK.PR', chr( welcher + 48) );
    IF exist( filnam) THEN werte_datei_aus( filnam, welcher);
    IF (p_string[ p_name, welcher] = '') AND (welcher = 1)
    THEN p_string[ p_name, welcher] := 'ASCII';
    IF p_string[ p_name, welcher] <> ''
    THEN BEGIN
           set_dtext   ( dl, index[welcher],p_string[ p_name, welcher],
                         SYSTEM_FONT, TE_CENTER);
           obj_setstate( dl, index[ welcher],( obj_state( dl,index[welcher])
                         & ~DISABLED ), FALSE);
         END; { Druckername war angegeben }
  END; { die 3 Drucker abfragen }
END; { procedure welche_drucker_sind_da }



{///////  BESTIMMUNG DER KOORDINATEN EINES DIALOG-OBJEKTS  /////////////////}

PROCEDURE objekt_koordinaten( ptr : dialog_ptr; index : INTEGER;
                              VAR x, y, w, h : INTEGER);
TYPE    baum_struktur   = ARRAY[0..999] OF ARRAY[0..11] OF INTEGER;
        baum_ptr        = ^baum_struktur;
VAR     magic : RECORD CASE BOOLEAN OF
                         FALSE : ( info : baum_ptr);
                         TRUE  : ( dlg  : dialog_ptr);
                       END; { record }


{~~~~~~~  BESTIMMUNG DER X- UND Y- KOORDINATEN EINES DIALOG-OBJEKTS  ~~~~~~~}

FUNCTION objc_offset( ptr : dialog_ptr; index : INTEGER; VAR x, y : INTEGER)
                    : INTEGER;
BEGIN
  addr_in[0]    := ptr;
  int_in[0]     := index;
  aes_call( 44, int_in, int_out, addr_in, addr_out); { objc_offset }
  x     := int_out[1];
  y     := int_out[2];
  objc_offset   := int_out[0];
END; { function objc_offset }

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

BEGIN { objekt_koordinaten }
  magic.dlg     := ptr;
  mist  := objc_offset( ptr, index, x, y);
{$P-}
  w     := magic.info^[ index, 10];
  h     := magic.info^[ index, 11];
{$P=}
END; { procedure objekt_koordinaten }


{///////  ZEICHNEN EINES DIALOG-OBJEKTS  ///////////////////////////////////}

FUNCTION objc_draw( ptr : dialog_ptr; index, tiefe, x, y, w, h : INTEGER)
                  : INTEGER;
CONST   RAND = 3;
BEGIN

{ Wegen Problemen mit Rand }
  IF index = ROOT
  THEN BEGIN
         x := x - RAND; y := y - RAND; w := w + 2*RAND; h := h + 2*RAND;
       END;
{ Wegen Problemen mit Rand }

  addr_in[0]    := ptr;
  int_in[0]     := index;
  int_in[1]     := tiefe;
  int_in[2]     := x;
  int_in[3]     := y;
  int_in[4]     := w;
  int_in[5]     := h;
  aes_call( 42, int_in, int_out, addr_in, addr_out); { objc_draw }
  objc_draw     := int_out[0];
END; { function objc_draw }

{///////  ZEICHNEN EINES SICH AUSDEHNENDEN RECHTECKS  //////////////////////}

FUNCTION graf_growbox( x1, y1, w1, h1, x2, y2, w2, h2 : INTEGER) : INTEGER;
BEGIN
  int_in[0]     := x1;
  int_in[1]     := y1;
  int_in[2]     := w1;
  int_in[3]     := h1;
  int_in[4]     := x2;
  int_in[5]     := y2;
  int_in[6]     := w2;
  int_in[7]     := h2;
  aes_call( 73, int_in, int_out, addr_in, addr_out);
  graf_growbox  := int_out[0];
END; { function graf_growbox }


{///////  ZEICHNEN EINS SCHRUMPFENDEN RECHTECKS  ///////////////////////////}

FUNCTION graf_shrinkbox( x1, y1, w1, h1, x2, y2, w2, h2 :INTEGER) :INTEGER;
BEGIN
  int_in[0]     := x1;
  int_in[1]     := y1;
  int_in[2]     := w1;
  int_in[3]     := h1;
  int_in[4]     := x2;
  int_in[5]     := y2;
  int_in[6]     := w2;
  int_in[7]     := h2;
  aes_call( 74, int_in, int_out, addr_in, addr_out);
  graf_shrinkbox:= int_out[0];
END; { function graf_shrinkbox }


{///////  ZEICHNEN EINES OBJEKTS, DAS EINEN ZAHLENWERT ENTHALTEN SOLL  /////}

PROCEDURE neuer_wert;  (* ( welcher, wert : INTEGER; zeichnen : BOOLEAN); *)
VAR     wert_str : STRING;
BEGIN
  long_to_string( wert, wert_str);
  set_dtext( dl, welcher, wert_str, SYSTEM_FONT, TE_CENTER);
  IF zeichnen
  THEN BEGIN
         objekt_koordinaten( dl, welcher, x, y, w, h);
         mist := objc_draw( dl, welcher, 0, x, y, w, h);
       END; { neu gezeichnet }
END; { procedure neuer_wert }


{///////  AUSMALEN DES FENSTERS MIT DEM HINTERGRUNDMUSTER  /////////////////}

PROCEDURE redraw_hintergrund( xc, yc, wc, hc : INTEGER);
VAR x, y, w, h : INTEGER;
BEGIN
  paint_color( BLACK);
  paint_style( MUSTER);
  hide_mouse;
  first_rect( fenster, x, y, w, h);
  WHILE (w <> 0) OR (h <> 0) DO
  BEGIN                                 { Teile des Fensters sind sichtbar }
    IF rect_intersect( xc, yc, wc, hc, x, y, w, h)
    THEN BEGIN
           set_clip( x, y, w, h);
           paint_rect( x, y, w, h);
         END; { ein Teil ist neu gezeichnet }
    next_rect( fenster, x, y, w, h);
  END; { sichtbare Teile }
  show_mouse;
END; { procedure redraw_hintergrund }


{///////  ERZEUGEN EINES FENSTERS MIT MAXIMALER GRSSE  //////////////////}

PROCEDURE unterlege_fenster;
BEGIN
  fenstername := '';          { Eigenes groes Fenster als Hintergrund }
                              { sonst Strung durch fremdes WM_REDRAW  }
  fenster := new_window( NONE, fenstername, 0, 0, 0, 0 );
  open_window ( fenster, 0, 0, 0, 0 );
  work_rect( fenster, f_x, f_y, f_w, f_h);
END; {procedure unterlege_fenster }


{///////  ERMITTELN, OB DIE MAUS INNERHALB EINES RECHTECKS GEDRCKT WURDE  /}

FUNCTION click_in_rechteck( x, y, w, h : INTEGER) : BOOLEAN;
VAR
    event,
    maus_x,
    maus_y,
    n_clicks,
    maus_status : INTEGER;
    msg         : message_buffer;
BEGIN
  event := get_event( E_BUTTON | E_TIMER,       { Maustaste oder Timer }
                           1,                   { linke Taste erwartet }
                           1,                   { drcken der Taste    }
                           1,                   { 1 mal clicken        }
                           0,                   { Timer auf 0 ms       }
                           FALSE, 0, 0, 0, 0,   { kein 1. Rechteck     }
                           FALSE, 0, 0, 0, 0,   { kein 2. Rechteck     }
                           msg,                 { keine message        }
                           mist,                { keine Taste          }
                           maus_status,         { Status der Maustaste }
                           n_clicks,            { Anzahl der clicks    }
                           maus_x,              { x-Position der Maus  }
                           maus_y,              { y-Position der Maus  }
                           mist              ); { Status der Tastatur  }

  IF event & E_BUTTON <> 0
  THEN click_in_rechteck := ( maus_x >= x ) AND ( maus_x <= ( x + w) ) AND
                            ( maus_y >= y ) AND ( maus_y <= ( y + h) )
  ELSE click_in_rechteck := FALSE;
END; { function click_in_rechteck }


{///////  FRGT, OB DIE DRUCKAUSGABE ABGEBROCHEN WERDEN SOLL  //////////////}

FUNCTION abbruchfrage : BOOLEAN;
VAR stop : BOOLEAN;
BEGIN
  redraw_hintergrund( f_x, f_y, f_w, f_h);
  mist := graf_shrinkbox( ST_X, ST_Y, ST_W, ST_H,
                          id_x, id_y, id_w, id_h);
  t := concat('[2][Soll die Druckausgabe wirklich| |',
                  '!!!   UND UNWIDERRUFLICH   !!!| |',
                  'abgebrochen werden ?][ Ja |Nein]');
  stop := do_alert( t, 1) = 1;
  IF NOT stop
  THEN BEGIN
         mist := graf_growbox( ST_X, ST_Y, ST_W, ST_H,
                               id_x, id_y, id_w, id_h);
         mist := objc_draw( id, ROOT, 99, id_x, id_y, id_w, id_h);
       END;
  abbruchfrage := stop;
END; { function abbruchfrage }


{///////  ERLEDIGT DIE DRUCKARBEITEN  //////////////////////////////////////}

PROCEDURE drucke_datei;
VAR alles_ok,
    abbruch,
    nummerierung,
    hand_rand   : BOOLEAN;
    q,
    z           : TEXT;
    seq         : steuerseq_typ;
    i,
    zeile,                      { zum Mitzhlen der Druckposition }
    spalte,
    zusatz_spalte,
    blatt_rand,
    fill_x,                     { Daten des mit dem Schiebebalken zu }
    fill_y,                     { fllenden Objekts }
    fill_w,
    fill_h,
    fill_w_a,
    fill_w_n    : INTEGER;

    stop_x,                     { Mae des Abbruch-Buttons }
    stop_y,
    stop_w,
    stop_h      : INTEGER;

    n           : LONG_INTEGER; { zum Mitzhlen der gelesenen Bytes }

BEGIN
  REPEAT
    reset( q, pfad);                    { ffnen der Quell-Datei }
    abbruch := eof( q);
    IF abbruch
    THEN BEGIN
           t := concat( '[3][Angegebene Datei|nicht gefunden !][Abbruch]');
           mist := do_alert( t, 1);
         END;
    alles_ok := drucker_bereit;         { Nachschauen, ob Drucker online }
    IF NOT alles_ok
    THEN BEGIN
           t := concat( '[2][Der Drucker ist nicht|empfangsbereit !| |',
                        'Weiterdrucken ?][ Ja |Nein]');
           abbruch := ( do_alert( t, 1) = 2 );
         END;

  UNTIL alles_ok OR abbruch;
  IF NOT abbruch                        { Initialisieren des Info-Dialogs }
  THEN BEGIN
         objekt_koordinaten( id, STOPBUTN, stop_x, stop_y, stop_w, stop_h);
         objekt_koordinaten( id, FUELLBOX, fill_x, fill_y, fill_w, fill_h);
         objekt_koordinaten( id, ROOT, id_x, id_y, id_w, id_h);
         mist := graf_growbox( ST_X,ST_Y,ST_W,ST_H, id_x, id_y, id_w, id_h);
         obj_setstate(id,DRUCKBTN, obj_state(id,DRUCKBTN) | SELECTED,FALSE);
         obj_setstate(id,STOPBUTN, obj_state(id,STOPBUTN)& ~SELECTED,FALSE);
         mist := objc_draw( id, ROOT, 99, id_x, id_y, id_w, id_h);
         paint_color( BLACK);
         end_dialog( id);
       END;
  IF NOT abbruch
  THEN BEGIN
         rewrite( z, OUT_DEVICE);       { ffnen der Ziel-Datei }
         n := 1;
         fill_w_a := 0;
         nummerierung := obj_state( dl, NUMMERJA) & SELECTED <> 0;

         hand_rand := TRUE;             { Vorerst Rand selber setzen }

         write( z, p_string[ p_init, drucker] );{ Initialisierung senden }

         IF p_string[ p_lrand, drucker] <> ''    { Linken Rand setzen }
         THEN BEGIN
                FOR i := 1 TO length( p_string[ p_lrand, drucker] ) DO
                BEGIN
                  IF p_string[ p_lrand, drucker, i] >= #$80
                  THEN write( z, chr( ord(p_string[ p_lrand, drucker, i])
                              - $80 + randbreite) )
                  ELSE write( z, p_string[ p_lrand, drucker, i] );
                END;
                hand_rand := FALSE;     { Rand kann doch der Drucker }
              END;

         IF obj_state( dl, PICASCHR) & SELECTED <> 0    { Pica setzen    }
         THEN BEGIN
                blatt_rand := randbreite;
                write( z, p_string[ p_pica, drucker]);
              END;

         IF obj_state( dl, ELITESCH) & SELECTED <> 0    { Elite setzen   }
         THEN BEGIN
                blatt_rand := round( randbreite * 1.2 );
                write( z, p_string[ p_elite, drucker]);
              END;

         IF obj_state( dl, SCHMALSC) & SELECTED <> 0    { Schmal setzen  }
         THEN BEGIN
                blatt_rand := round( randbreite * 1.7 );
                write( z, p_string[ p_schmal, drucker]);
              END;

         zeile := 0;                            { Startwert }
         WHILE NOT eof( q) AND NOT abbruch DO   { Solange noch was da ist }
         BEGIN
           zeile := zeile + 1;                  { Nchste Zeile }
           IF ( (zeile MOD p_vor[p_seitlaen,drucker])=1 ) AND (zeile > 1)
           THEN IF obj_state( dl, PERFORJA) & SELECTED <> 0 THEN page( z);

           IF hand_rand                 { Rand mit Spaces erzeugen }
           THEN write( z, ' ' : blatt_rand);

           IF nummerierung              { Hinzufgen der Zeilennummer }
           THEN BEGIN
                  write( z, zeile : 8, ' ' : 5);
                  zusatz_spalte := 13;
                END
           ELSE zusatz_spalte := 0;
           spalte := zusatz_spalte;

           WHILE NOT eoln(q) AND NOT abbruch DO     { Zeile drucken }
           BEGIN
             IF spalte < zeilenbreite
             THEN BEGIN
                    IF ( q^ IN [ #32 .. #126] )
                    THEN BEGIN
                           z^ := q^;
                           put( z);
                         END
                    ELSE BEGIN
                           seq := p_name;       { unmglicher Startwert }
                           CASE q^ OF

                           { HT} #$9  :
                             BEGIN      { Tabulator behandeln }
                               i := tab_weite -
                                    (spalte - zusatz_spalte) MOD tab_weite;
                               write( z, ' ' : i);
                               spalte := spalte + i - 1;
                             END;
                           {  } #$81 : seq := p_kl_ue;
                           {  } #$84 : seq := p_kl_ae;
                           {  } #$8E : seq := p_gr_ae;
                           {  } #$94 : seq := p_kl_oe;
                           {  } #$99 : seq := p_gr_oe;
                           {  } #$9A : seq := p_gr_ue;
                           {  } #$9E : seq := p_dt_sz;
                           {  } #$DD : seq := p_dt_para;
                           OTHERWISE  : write(z,' ');{ durch Space ersetzen }
                         END; { case }
                         IF seq <> p_name       { Startwert gendert }
                         THEN write( z, p_string[ seq, drucker]);
                       END; { Sonderzeichen }
                  END; { Zeichen gedruckt, weil noch nicht am Rand }
             get( q);
             spalte := spalte + 1;
             n := n + 1;
           END; { while not Zeilenende der Quelle erreicht }
           readln( q);          { Neue Zeile einlesen }
           n := n + 2;
           writeln( z);         { Zeilenende auf Drucker geschrieben }

           IF click_in_rechteck( stop_x, stop_y, stop_w, stop_h)
           THEN abbruch := abbruchfrage;        { Schauen, ob Abbruch }
           fill_w_n := round ( fill_w * n / q_laenge );
           IF fill_w_n > fill_w_a
           THEN BEGIN                           { Schiebebalken zeichnen }
                  fill_w_a := fill_w_n;
                  set_clip( fill_x, fill_y, fill_w, fill_h);
                  paint_style( 5);
                  hide_mouse;
                  paint_rect( fill_x, fill_y, fill_w_n, fill_h);
                  show_mouse;
                END;
           IF abbruch THEN write( z, #24); { ASCII-Zeichen CAN bermitteln }

         END; { Dateiende erreicht }

         page( z);                              { Seitenvorschub erzeugen }
         write( z, p_string[ p_exit, drucker] );{ De-Initialisierung }
       END; { Es durfte gedruckt werden }
END; { procedure drucke_datei }


{///////  DIALOG BERMALEN UND SCHRUMPFEN LASSEN  //////////////////////////}

PROCEDURE verstecke_dialog;
BEGIN
  redraw_hintergrund( f_x, f_y, f_w, f_h);
  mist := graf_shrinkbox( ST_X, ST_Y, ST_W, ST_H, dl_x, dl_y, dl_w, dl_h);
END; { procedure verstecke_dialog }


{///////  DIALOG WACHSEN LASSEN UND NEU ZEICHNEN  //////////////////////////}

PROCEDURE zeige_dialog;
BEGIN
  mist := graf_growbox( ST_X, ST_Y, ST_W, ST_H, dl_x, dl_y, dl_w, dl_h);
  mist := objc_draw( dl, ROOT, 99, dl_x, dl_y, dl_w, dl_h);
END; { procedure zeige_dialog }


{///////  DATEINAMEN AUS FILE-SELECTOR-BOX ERMITTELN  //////////////////////}

PROCEDURE ermittle_datei;
VAR file_erhalten : BOOLEAN;
    name,
    extension,
    neu_vorschlag,
    neu_pfad      : STRING;

BEGIN
  neu_vorschlag := vorschlag;
  neu_pfad      := '';
  file_erhalten := get_in_file( neu_vorschlag, neu_pfad);
  redraw_hintergrund( f_x, f_y, f_w, f_h);
  IF file_erhalten
  THEN BEGIN
         fsetdta ( dta);
         IF exist( neu_pfad)
         THEN BEGIN
                pfad := neu_pfad;
                vorschlag := neu_vorschlag;
                q_laenge := dta.laenge;

                obj_setstate( dl, STARTBTN, ( obj_state
                             ( dl, STARTBTN) & ~DISABLED), FALSE);
                analyze_path( pfad, name, extension);
                IF length( extension) > 0
                THEN name := concat( name, '.', extension);
                set_dtext( dl, DATEINAM, name, SYSTEM_FONT, TE_RIGHT);
                set_dtext( id, OUTFNAME, name, SYSTEM_FONT, TE_RIGHT);
              END
         ELSE BEGIN
                obj_setstate( dl, STARTBTN, ( obj_state( dl, STARTBTN)
                              | DISABLED), FALSE);
                t := '[2][Die angegebene Datei| |existiert nicht !][ OK ]';
                mist := do_alert( t, 1);
                set_dtext( dl,DATEINAM,'????????.???',SYSTEM_FONT,TE_RIGHT);
              END;
       END { file_erhalten }
  ELSE
    BEGIN
      obj_setstate( dl,STARTBTN, obj_state( dl, STARTBTN)|DISABLED, FALSE);
      set_dtext( dl, DATEINAM, '????????.???', SYSTEM_FONT, TE_LEFT);
    END;
END; { procedure ermittle_datei }


{///////  MANAGEMENT DES HAUPT-DIALOGS  ////////////////////////////////////}

PROCEDURE action;
VAR     knopf : INTEGER;
BEGIN { action }
  mist := graf_growbox( ST_X, ST_Y, ST_W, ST_H, dl_x, dl_y, dl_w, dl_h);
  knopf := do_dialog( dl, NONE);
  WHILE knopf <> ABBRUBTN DO
    BEGIN
{---------------------------------------------------------------------------}
CASE knopf OF
QUELLBTN : BEGIN                        { Quelldatei-Button angewhlt }
             verstecke_dialog;
             ermittle_datei;
             obj_setstate( dl, knopf, obj_state(dl,knopf)& ~SELECTED,FALSE);
             zeige_dialog;
           END;
LPTR1BTN,
LPTR2BTN,
LPTR3BTN : BEGIN                        { Drucker gewechselt }
             neuer_drucker( knopf);
             neuer_wert( TABWEITE, tab_weite,    TRUE);
             neuer_wert( RANDBREI, randbreite,   TRUE);
             neuer_wert( ZEILBREI, zeilenbreite, TRUE);
           END;
NUMMERJA : BEGIN                        { Es soll nummeriert werden }
             IF (obj_state( dl,PICASCHR)&SELECTED<>0) AND (zeilenbreite<96)
             THEN BEGIN
                    verstecke_dialog;
                    t := concat('[2][Zeilenbreite ist zu klein|fr ',
                                'Nummerierung !| |Schriftart wechseln ?]',
                                '[ Ja | Nein ]');
                    IF do_alert( t, 1) = 1
                    THEN BEGIN
                           obj_setstate( dl,PICASCHR, obj_state(dl,PICASCHR)
                                         & ~SELECTED, FALSE);
                           obj_setstate( dl,ELITESCH, obj_state(dl,ELITESCH)
                                         | SELECTED, FALSE);
                           zeilenbreite := p_vor[p_elite_breit, drucker];
                           neuer_wert( ZEILBREI, zeilenbreite, FALSE);
                         END;
                    zeige_dialog;
                  END;
           END;
NUMMERNE : BEGIN                        { Keine Nummerierung erwnscht }
           END;
PICASCHR : BEGIN                        { Pica-Schrift gewhlt }
             zeilenbreite := p_vor[ p_pica_breit, drucker];
             neuer_wert( ZEILBREI, zeilenbreite, TRUE);
           END;
ELITESCH : BEGIN                        { Elite-Schrift gewhlt }
             zeilenbreite := p_vor[ p_elite_breit, drucker];
             neuer_wert( ZEILBREI, zeilenbreite, TRUE);
           END;
SCHMALSC : BEGIN                        { Schmal-Schrift gewhlt }
             zeilenbreite := p_vor[ p_schmal_breit, drucker];
             neuer_wert( ZEILBREI, zeilenbreite, TRUE);
           END;
PERFORJA : BEGIN                        { Perforation berspringen }
           END;
PERFORNE : BEGIN                        { Perforation nicht berspringen }
           END;
TABMINUS : IF tab_weite > 1             { Tabulator erniedrigen }
           THEN BEGIN
                  tab_weite := tab_weite - 1;
                  neuer_wert( TABWEITE, tab_weite, TRUE);
                END;
TABUPLUS : IF tab_weite < 50            { Tabulator erhhen }
           THEN BEGIN
                  tab_weite := tab_weite + 1;
                  neuer_wert( TABWEITE, tab_weite, TRUE);
                END;
RANDMINU : IF randbreite > 0            { Randbreite erniedrigen }
           THEN BEGIN
                  randbreite := randbreite - 1;
                  neuer_wert( RANDBREI, randbreite, TRUE);
                END;
RANDPLUS : IF randbreite < 999          { Randbreite erhhen }
           THEN BEGIN
                  randbreite := randbreite + 1;
                  neuer_wert( RANDBREI, randbreite, TRUE);
                END;
ZLBRMINU : IF zeilenbreite > 5          { Zeilenbreite erniedrigen }
           THEN BEGIN
                  zeilenbreite := zeilenbreite - 1;
                  neuer_wert( ZEILBREI, zeilenbreite, TRUE);
                END;
ZLBRPLUS : IF zeilenbreite < 999        { Zeilenbreite erhhen }
           THEN BEGIN
                  zeilenbreite := zeilenbreite + 1;
                  neuer_wert( ZEILBREI, zeilenbreite, TRUE);
                END;
STARTBTN : BEGIN                        { Start des Drucks }
             verstecke_dialog;
             drucke_datei;
             obj_setstate( dl,knopf, obj_state(dl,knopf) & ~SELECTED,FALSE);
             zeige_dialog;
           END;
OTHERWISE: BEGIN                { nichts davon, tritt z.B. bei Doppelclick }
           END;                 { auf die Pfeilboxen auf }
END; { case }
{---------------------------------------------------------------------------}

      knopf := redo_dialog( dl, NONE);

    END; { while not Abbruch }
  end_dialog( dl);
  verstecke_dialog;
END; { procedure action }


{///////  H A U P T P R O G R A M M  ///////////////////////////////////////}

BEGIN { Hauptprogramm }
  IF init_gem >= 0                              { Start ins GEM }
  THEN
  BEGIN
    IF NOT load_resource ( RSC_DATEI )          { RSC-Datei laden }
    THEN BEGIN
           t := concat('[3][Resource - Datei|', RSC_DATEI,
                         '|nicht gefunden !][Abbruch]');
           mist := do_alert( t, 1);
         END { RSC-Datei nicht gefunden }
    ELSE BEGIN
           set_mouse( M_ARROW);

           unterlege_fenster;                    { Eigenes, groes Fenster }
           redraw_hintergrund( f_x, f_y, f_w, f_h); { vollstndig ausmalen }

           find_dialog( HAUPTDLG, dl);          { Dialog-Pointer setzen }
           center_dialog( dl);                  { und Dialog zentrieren }

           find_dialog( DRUCKINF, id);
           center_dialog( id);

           objekt_koordinaten( dl, ROOT, dl_x, dl_y, dl_w, dl_h);
           welche_drucker_sind_da;      { Schauen, ob Druckeranpassungen da }
           initialisiere;

           action;                      { Hauptdialog fhren }

           close_window  ( fenster ); { Hintergrundfenster wieder entfernen }
           delete_window ( fenster );
         END; { Alles war OK }
    exit_gem;
  END; { init_gem erfolgreich }
END.

